<?php

/*
 * @version		$Id: approval.php 3.0 2017-01-26 $
 * @package		All Video Share
 * @copyright   Copyright (C) 2012-2017 MrVinoth
 * @license     GNU/GPL http://www.gnu.org/licenses/gpl-2.0.html
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class AllVideoShareModelApproval extends AllVideoShareModel {
	
	public function getItem() {

		 $cid = JRequest::getVar( 'cid', array(0), '', 'array' );
         $id = (int) $cid[0];
		 
         $row = JTable::getInstance( 'Videos', 'AllVideoShareTable' );
        
         $row->load( $id );

         return $row;
		 
	}
	
	public function getItems() {
	
		 $app = JFactory::getApplication();	
		 $db = JFactory::getDBO();
		 
		 $option = JRequest::getCmd( 'option' );
		 $view = JRequest::getCmd( 'view' );
		 
		 $limit = $app->getUserStateFromRequest( 'global.list.limit', 'limit', $app->getCfg( 'list_limit' ), 'int' );
		 $limitstart = $app->getUserStateFromRequest( $option.$view.'.limitstart', 'limitstart', 0, 'int' );
		 $limitstart = ( $limit != 0 ? ( floor( $limitstart / $limit ) * $limit ) : 0 );
		 $filter_category = $app->getUserStateFromRequest( $option.$view.'filter_category', 'filter_category', '', 'string' );
		 $search = $app->getUserStateFromRequest( $option.$view.'search', 'search', '', 'string' );
		 $search = JString::strtolower( $search );

         $query = "SELECT * FROM #__allvideoshare_videos";
		 
		 $where = array();		 
		 $where[] = "published=0";
		 
		 if( $filter_category && $filter_category != JText::_( 'SELECT_BY_CATEGORY' ) ) {
			$where[] = 'category='.$db->Quote( $filter_category );
		 }
		
		 if( $search ) {
		 	$escaped = $db->escape( $search, true );
			$where[] = 'LOWER(title) LIKE '.$db->Quote( '%'.$escaped.'%', false );
		 }

		 $where = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );		 
		 $query .= $where;
		 
         $db->setQuery( $query, $limitstart, $limit );
         $items = $db->loadObjectList();
		 
         return $items;
		 
	}
	
	public function getTotal() {
	
		 $app = JFactory::getApplication();	
		 $db = JFactory::getDBO();
		 
		 $option = JRequest::getCmd( 'option' );
		 $view = JRequest::getCmd( 'view' );
		 
		 $filter_category = $app->getUserStateFromRequest( $option.$view.'filter_category', 'filter_category', '', 'string' );
		 $search = $app->getUserStateFromRequest( $option.$view.'search', 'search', '', 'string' );
		 $search = JString::strtolower( $search );
         
         $query = "SELECT COUNT(id) FROM #__allvideoshare_videos";
		 
		 $where = array();
		 $where[] = "published=0";

		 if( $filter_category && $filter_category != JText::_( 'SELECT_BY_CATEGORY' ) ) {
			$where[] = 'category='.$db->Quote( $filter_category );
		 }
		 
		 if( $search ) {
		 	$escaped = $db->escape( $search, true );
			$where[] = 'LOWER(title) LIKE '.$db->Quote( '%'.$escaped.'%', false );
		 }

		 $where = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );		 
		 $query .= $where;

         $db->setQuery( $query );
         $count = $db->loadResult();
		 
         return $count;
		 
	}
	
	public function getPagination() {
	
		 $app = JFactory::getApplication();	
		 
		 $option = JRequest::getCmd( 'option' );
		 $view = JRequest::getCmd( 'view' );
		 
		 $total = $this->getTotal();
		 $limit = $app->getUserStateFromRequest( 'global.list.limit', 'limit', $app->getCfg( 'list_limit' ), 'int' );
		 $limitstart = $app->getUserStateFromRequest( $option.$view.'.limitstart', 'limitstart', 0, 'int' );
		 $limitstart = ( $limit != 0 ? ( floor( $limitstart / $limit ) * $limit ) : 0 );
     
    	 jimport( 'joomla.html.pagination' );
		 $pagination = new JPagination( $total, $limitstart, $limit );
		 
         return $pagination;
		 
	}
	
	public function getLists() {
	
		 $app = JFactory::getApplication();	
		 
		 $option = JRequest::getCmd( 'option' );
		 $view = JRequest::getCmd( 'view' );
		 
		 $filter_category = $app->getUserStateFromRequest( $option.$view.'filter_category', 'filter_category', '', 'string' );
		 $search = $app->getUserStateFromRequest( $option.$view.'search', 'search', '', 'string' );
		 $search = JString::strtolower ( $search );
     
    	 $lists = array();
		 $lists['search'] = $search;
		 $lists['categories'] = AllVideoShareHtml::ListCategories( 'filter_category', $filter_category, 'onchange="this.form.submit();"' );	
		 
         return $lists;
		 
	}
	
	public function getVideosCountWaitingApproval() {
	
         $db = JFactory::getDBO();
		 
         $query  = "SELECT COUNT(id) FROM #__allvideoshare_videos WHERE published=0";
         $db->setQuery( $query );
         $count = $db->loadResult();
		 
         return $count;
		 
	}

	public function save() {
	
		 $app = JFactory::getApplication();
		 
		 $cid = JRequest::getVar( 'cid', array(0), '', 'array' );
      	 $id = (int) $cid[0];
		 
	  	 $row = JTable::getInstance( 'Videos', 'AllVideoShareTable' );
      	 $row->load( $id );
	
      	 if( ! $row->bind( JRequest::get( 'post' ) ) ) {
		 	JError::raiseError( 500, $row->getError() );
	  	 }

		 $row->title = AllVideoShareUtils::safeString( $row->title );
	  	 
		 $slug = AllVideoShareUtils::getVideoSlug( $row );
		 $row->slug = $slug;
		 
	  	 $row->description = JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWHTML );
		 $row->thirdparty = JRequest::getVar( 'thirdparty', '', 'post', 'string', JREQUEST_ALLOWRAW );
	  
	  	 if( $row->type == 'upload' ) {
		 	jimport( 'joomla.filesystem.folder' );
			
		 	$dir = JHTML::_( 'date', 'now', 'Y-m-d', false );
		 	if( ! JFolder::exists( ALLVIDEOSHARE_UPLOAD_BASE ) ) {
				JFolder::create( ALLVIDEOSHARE_UPLOAD_BASE );
			}
		
			$row->video = AllVideoShareUpload::doUpload( 'upload_video', $dir, $row->video );
			$row->hd = AllVideoShareUpload::doUpload( 'upload_hd', $dir, $row->hd );
	  		$row->thumb = AllVideoShareUpload::doUpload( 'upload_thumb', $dir, $row->thumb );
			$row->preview = AllVideoShareUpload::doUpload( 'upload_preview', $dir, $row->preview );
	  	 }
		 
		 if( $row->type == 'youtube' ) {
		 	$v = AllVideoShareUtils::getYouTubeVideoId( $row->video );
		 	$row->video = 'https://www.youtube.com/watch?v=' . $v;
			if(!$row->thumb) {
          		$row->thumb = 'https://img.youtube.com/vi/'.$v.'/default.jpg';
			}
			if(!$row->preview) {
		 		$row->preview = 'https://img.youtube.com/vi/'.$v.'/0.jpg';
			}
	     }
		 
		 if( $row->type != 'upload' && $row->type != 'youtube' ) {
			$row->video = AllVideoShareUtils::safeString( $row->video );
			$row->hd = AllVideoShareUtils::safeString( $row->hd );
		 }
		 
		 if( $row->type == 'rtmp' ) {
			$row->streamer = AllVideoShareUtils::safeString( $row->streamer );
		 }
		 
		 $row->reorder( "category='" . $row->category . "'" );
		 
	  	 if( ! $row->store() ) {
			JError::raiseError( 500, $row->getError() );
	  	 }

      	 $msg = JText::_( 'ADDED_TO_VIDEOS_SECTION' );
         $link = 'index.php?option=com_allvideoshare&view=approval';

	  	 $app->redirect( $link, $msg, 'message' );
		 
	}
	
	public function cancel() {
	
		 $app = JFactory::getApplication();
		 
		 $link = 'index.php?option=com_allvideoshare&view=approval';
	     $app->redirect( $link );
		 
	}	

	public function delete() {
	
		$app = JFactory::getApplication();
		$db = JFactory::getDBO();
		
        $cid = JRequest::getVar( 'cid', array(), '', 'array' );        
        $cids = implode( ',', $cid );
		
        if( count( $cid ) ) {
            $query = "DELETE FROM #__allvideoshare_videos WHERE id IN ( $cids )";
            $db->setQuery( $query );
            if( ! $db->query() ) {
                echo "<script> alert('".$db->getErrorMsg()."');window.history.go(-1); </script>\n";
            }
        }
		
        $app->redirect( 'index.php?option=com_allvideoshare&view=approval' );
		
	}
	
	public function publish() {
	
		$app = JFactory::getApplication();
		
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
        $publish = ( JRequest::getCmd( 'task' ) == 'publish' ) ? 1 : 0;
			
        $row = JTable::getInstance( 'Videos', 'AllVideoShareTable' );
        $row->publish( $cid, $publish );
		
        $app->redirect( 'index.php?option=com_allvideoshare&view=approval' );
		
    }
		
}