<?php

/*
 * @version		$Id: playlist.php 3.0 2017-01-26 $
 * @package		All Video Share
 * @copyright   Copyright (C) 2012-2017 MrVinoth
 * @license     GNU/GPL http://www.gnu.org/licenses/gpl-2.0.html
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class AllVideoShareModelPlayList extends AllVideoShareModel {

	public function buildXml() {
	
		ob_clean();
		header( "content-type:text/xml;charset=utf-8" );
		echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
		echo '<playlist>'."\n";
		echo $this->buildNodes();
		echo '</playlist>'."\n";
		exit();
		
	}
	
	public function buildNodes() {
	
		$items = $this->getItems();	
		$link  = $this->getLink();	
		$node  = '';
		
		foreach( $items as $item ) {
			$node .= '<item>'."\n";
			$node .= '<thumb>'.AllVideoShareUtils::getImage( $item->thumb ).'</thumb>'."\n";
			$node .= '<title><![CDATA['.$item->title.']]></title>'."\n";
			$node .= '<link>'.JRoute::_( $link.'slg='.$item->slug ).'</link>'."\n";
			$node .= '</item>'."\n";
		}
		
		return $node;
		
	}
	
	public function getItems() {
	
		$category = $this->getCategory();
		
		$db = JFactory::getDBO();
        $query = "SELECT * FROM #__allvideoshare_videos WHERE published=1 AND category=" . $db->Quote( $category ) . " AND id!=" . $db->Quote( JRequest::getInt( 'vid' ) );
        $db->setQuery( $query );
        $items = $db->loadObjectList();
        
		return $items;
		
	}
	
	public function getCategory() {
	
         $db = JFactory::getDBO();
		 
         $query  =  "SELECT category FROM #__allvideoshare_videos WHERE id=" . $db->Quote( JRequest::getInt( 'vid' ) );
         $db->setQuery( $query );
         $item = $db->loadResult();
		 
         return $item;
		 
	}
	
	public function getLink() {
	
		$db = JFactory::getDBO();

        $query = "SELECT * FROM #__allvideoshare_players WHERE id=" . $db->Quote( JRequest::getInt( 'pid' ) );
        $db->setQuery( $query );
        $item = $db->loadObject();
		 
		$link = '';
		 
		if( $item->customplayerpage ) {
		 	$link = $item->customplayerpage;
		} else {
		 	$link = 'index.php?option=com_allvideoshare&view=video';
			$link.= JRequest::getInt( 'Itemid' ) ? '&Itemid=' . JRequest::getInt( 'Itemid' ) : '';
		}
		 
		$qs = ( ! strpos( $link, '?' ) ) ? '?' : '&';
		 
		return $link.$qs;
		 
	}

}